package xyz.imaf6971.volgait.models;

import javax.persistence.*;
import java.time.LocalDateTime;

@Entity
@Table(name = "advertisement")
public class Advertisement extends AbstractEntity {

    @Column(name = "title", nullable = false)
    private String title;

    @Column(name = "textdata", nullable = false)
    private String text;

    @Column(name = "creation_date", nullable = false)
    private LocalDateTime creationDate;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "type_id", nullable = false)
    private AdvertisementType type;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "user_id", nullable = false)
    private User author;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "subcategory_id", nullable = false)
    private AdvertisementSubcategory subcategory;

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getText() {
        return text;
    }

    public void setText(String text) {
        this.text = text;
    }

    public LocalDateTime getCreationDate() {
        return creationDate;
    }

    public void setCreationDate(LocalDateTime creationDate) {
        this.creationDate = creationDate;
    }

    public AdvertisementType getType() {
        return type;
    }

    public void setType(AdvertisementType type) {
        this.type = type;
    }

    public AdvertisementSubcategory getSubcategory() {
        return subcategory;
    }

    public void setSubcategory(AdvertisementSubcategory subcategory) {
        this.subcategory = subcategory;
    }

    public User getAuthor() {
        return author;
    }

    public void setAuthor(User author) {
        this.author = author;
    }
}
