package xyz.imaf6971.volgait.service.impl;

import org.springframework.stereotype.Service;
import xyz.imaf6971.volgait.exceptions.AdvertisementSubcategoryNotFoundException;
import xyz.imaf6971.volgait.models.AdvertisementSubcategory;
import xyz.imaf6971.volgait.repository.AdvertisementSubcategoryRepository;
import xyz.imaf6971.volgait.service.AdvertisementSubcategoryService;

@Service
public class AdvertisementSubcategoryServiceImpl implements AdvertisementSubcategoryService {

    private final AdvertisementSubcategoryRepository subcategoryRepository;

    public AdvertisementSubcategoryServiceImpl(AdvertisementSubcategoryRepository subcategoryRepository) {
        this.subcategoryRepository = subcategoryRepository;
    }

    @Override
    public AdvertisementSubcategory getSubcategoryById(Long id) {
        return subcategoryRepository.findById(id)
                .orElseThrow(() -> new AdvertisementSubcategoryNotFoundException("No subcategory with id " + id));
    }
}
