package xyz.imaf6971.volgait.service.impl;

import org.springframework.stereotype.Service;
import xyz.imaf6971.volgait.exceptions.AdvertisementTypeNotFoundException;
import xyz.imaf6971.volgait.models.AdvertisementType;
import xyz.imaf6971.volgait.repository.AdvertisementTypeRepository;
import xyz.imaf6971.volgait.service.AdvertisementTypeService;

@Service
public class AdvertisementTypeServiceImpl implements AdvertisementTypeService {

    private final AdvertisementTypeRepository advertisementTypeRepository;

    public AdvertisementTypeServiceImpl(AdvertisementTypeRepository advertisementTypeRepository) {
        this.advertisementTypeRepository = advertisementTypeRepository;
    }

    @Override
    public AdvertisementType getTypeById(Long id) {
        return advertisementTypeRepository.findById(id)
                .orElseThrow(() -> new AdvertisementTypeNotFoundException("advertisement type with id " + id + " not found"));
    }
}
