CREATE TABLE app_roles (
    id bigserial PRIMARY KEY,
    title varchar(255) UNIQUE NOT NULL
);

CREATE TABLE app_users (
    id bigserial PRIMARY KEY,
    is_active BOOLEAN NOT NULL,
    username varchar(255) UNIQUE NOT NULL,
    password varchar(255) NOT NULL,
    role_id bigint NOT NULL REFERENCES app_roles (id)
);

CREATE TABLE advertisement_type (
    id bigserial PRIMARY KEY,
    title varchar(255) NOT NULL
);

CREATE TABLE advertisement_category (
    id bigserial PRIMARY KEY,
    title varchar(255) NOT NULL
);

CREATE TABLE advertisement_subcategory (
    id bigserial PRIMARY KEY,
    title varchar(255) NOT NULL,
    main_category_id bigint NOT NULL REFERENCES advertisement_category (id)
);

CREATE TABLE advertisement (
    id bigserial PRIMARY KEY,
    title VARCHAR(255) NOT NULL,
    textdata TEXT NOT NULL,
    creation_date TIMESTAMP NOT NULL,
    user_id bigint NOT NULL REFERENCES app_users (id),
    type_id bigint NOT NULL REFERENCES advertisement_type (id),
    subcategory_id bigint NOT NULL REFERENCES advertisement_subcategory (id)
);